' Copyright (c) 2013 SoftConseil Inc. <support@myowntelco.net>
'
' WARNING! Commercial Software, All Use Must Be Licensed 
' This software is protected by Canadian Copyright Law and International Treaties. Unauthorized use,
' duplication, reverse engineering, any form of redistribution, or use in part or in whole other than
' by prior, express, printed and signed license for use is subject to civil and criminal prosecution.
' If you have received this file in error, please notify copyright holder and destroy this and any
' other copies as instructed.
	
bDebug = false

on error goto 0

Dim objShell, objFSO
Dim sComputerName, sUserName, sServerName, sFileTransferProxy, sDomain, iPort, sConnectionSecurity

'--- SET CONFIGURATION
'=============================================================================
sServerName 		= "kaly.im"
sFileTransferProxy 	= "kaly.im"
sDomain 			= "kaly.im"
iPort 				= "5222"

'Options: 	opportunistic_tls 	("Use encryption if available")
'			require_tls 		("Require encryption")
'			old_ssl 			("Use old-style SSL") 
sConnectionSecurity = "require_tls" 

Set objShell 		= CreateObject("Wscript.shell")
Set objFso 			= CreateObject("Scripting.FileSystemObject")
Set WshNetwork 		= CreateObject("WScript.Network")

'Get local computer and username running this script
sComputerName 		= WshNetwork.ComputerName
'sUserName 			= WshNetwork.UserName
sUserName 			= ""
sPassword			= ""
'=============================================================================

On Error Resume Next

intAnswer = Msgbox("This script will customize your Pidgin program installation and any previously configured account will be overwritten; do you wish to continue?", vbYesNo, "Kaly Chat Assistant Customization Script")

If intAnswer = vbNo Then
    Msgbox "Script stopped."
	wscript.quit
End If

sUserName = InputBox( "What is the Kaly chat 6 digits username that was provided to you?")
if (not isNumeric(sUserName)) or sUserName < 1 or sUserName > 999999 Then
	Msgbox "Username have 6 digits. Script stopped!"
	wscript.quit
End If

sPassword = InputBox( "What is the password?")
if sPassword = "" Then
	Msgbox "Password not provided. Script stopped!"
	wscript.quit
End If

'--- CHECK PIDGIN INSTALLATION
'Place path of Pidgin installation into variable.  This is pulled via the 
' registry.  If Pidgin is installed correctly, it should give us a full 
' path to the exe.
sPidginPath 		= lcase(getAppPath())

'If we have any errors getting to the registry key, then quit the script.
If Err.Number <> 0 then Wscript.Quit

On Error Goto 0

'--- GET PIDGIN PATH
'If the key returns a path, let's check to see if pidgin.exe is found.
If reportfilestatus(sPidginPath) = true then
	if bdebug = true then wscript.echo "Pidgin.exe found at " & sPidginPath
	sPidginPath = replace(sPidginPath,"pidgin.exe","")

'If Pidgin is NOT installed correctly, then quit.
Else
	if bdebug = true then wscript.echo "Pidgin.exe not found."
	wscript.quit
End if

'--- GET CURRENT PATH
sScriptPath 		= objShell.CurrentDirectory & "\"
if bdebug = true then wscript.echo "Using source path of " & sScriptPath & " for configuration files."

'--- GET PROFILE PATH
sProfilePath 		= lcase(objShell.ExpandEnvironmentStrings("%UserProfile%"))
if bdebug = true then wscript.echo "User's profile path: " & sProfilePath 

'--- PROFIL SETUP
'--- Windows 7/Vista
If instr(lcase(sProfilePath),"users\") then

	'If the settings folder doesn't exist, then create it (at this point we should
	' have already determined if Pidgin was installed or not 
	If ReportFolderStatus(sProfilePath & "\appdata\roaming\.purple") = false then
		if bdebug = true then wscript.echo "Creating Pidgin profile folder..."
		objfso.CreateFolder(sProfilePath & "\appdata\roaming\.purple")
	End if

	'Copy all XML files from our source folder to edit later.
	if bdebug = true then wscript.echo "Configuring Pidgin chat profile..." 
	objfso.CopyFolder sScriptPath & "\xml", sProfilePath & "\appdata\roaming\.purple",true	

	'Copy all themes, sounds, gtk settings into the user folder.
	objfso.CopyFolder sScriptPath & "\files", sProfilePath & "\appdata\roaming\.purple",true
	
	'Specify the final path for the accounts.xml
	sAccountsXML = sProfilePath & "\appdata\roaming\.purple\accounts.xml"
	sPrefsXML = sProfilePath & "\appdata\roaming\.purple\prefs.xml"

'--- XP
ElseIf instr(lcase(sProfilePath),"documents and settings\") then

	'If the settings folder doesn't exist, then create it (at this point we should
	' have already determined if Pidgin was installed or not 
	If ReportFolderStatus(sProfilePath & "\application data\.purple") = false then
		if bdebug = true then wscript.echo "Creating Pidgin profile folder..."
		objfso.CreateFolder(sProfilePath & "\application data\.purple")
			
	End If 
	
	'Copy all XML files from our source folder to edit later.
	if bdebug = true then wscript.echo "Configuring Pidgin chat profile..." 
	objfso.CopyFolder sScriptPath & "\xml", sProfilePath & "\application data\.purple",true

	'Copy all themes, sounds, gtk settings into the user folder.
	objfso.CopyFolder sScriptPath & "\files", sProfilePath & "\application data\.purple",true

	'Specify the final path for the accounts.xml
	sAccountsXML = sProfilePath & "\application data\.purple\accounts.xml"
	sPrefsXML = sProfilePath & "\appdata\roaming\.purple\prefs.xml"
End If

On Error Resume Next

'--- PLUGINS
if bdebug = true then wscript.echo "Now copying plugins from " & sScriptPath & "\plugins to " & sPidginPath & "\plugins"
objFSO.CopyFile sScriptPath & "\plugins\*.*",sPidginPath & "\plugins"

'--- SIPE
if bdebug = true then wscript.echo "Now copying SIP plugins from " & sScriptPath & "\sipe to " & sPidginPath & "\"
objFSO.CopyFile sScriptPath & "\sipe\*.*",sPidginPath & "\"

'--- GLOSSY THEME
if bdebug = true then wscript.echo "Now copying glossy theme from " & sScriptPath & "\glossy to " & sPidginPath & "\pixmaps"
objfso.CopyFolder sScriptPath & "\glossy",sPidginPath & "\pixmaps"

if bdebug = true then wscript.echo "Customizing accounts..."

'--- CUSTOMIZE XML FILES
Const ForReading = 1
Const ForWriting = 2
Set objFSO = CreateObject("Scripting.FileSystemObject")

Set objFile = objFSO.OpenTextFile(sAccountsXML, ForReading)
strText = objFile.ReadAll
objFile.Close
strNewFile = Replace(strText, "USERNAME", sUserName & "@" & sDomain & "/" & sComputerName)
strNewFile = Replace(strNewFile, "PASSWORD", sPassword)
Set objFile = objFSO.OpenTextFile(sAccountsXML, ForWriting)
objFile.WriteLine strNewFile
objFile.Close

Set objFile = objFSO.OpenTextFile(sPrefsXML, ForReading)
strText = objFile.ReadAll
objFile.Close
strNewFile = Replace(strText, "PATHPIDGIN", sPidginPath)
strNewFile = Replace(strNewFile, "PATHPURPLE", sProfilePath & "\appdata\roaming\.purple")
Set objFile = objFSO.OpenTextFile(sPrefsXML, ForWriting)
objFile.WriteLine strNewFile
objFile.Close

wscript.echo "Finished. You can now start Pidgin!"

'--- FUNCTIONS

Function ReportFileStatus(filespec)
   Dim msg
   If (objFSO.FileExists(filespec)) Then
      msg = true
   Else
      msg = false
   End If
   ReportFileStatus = msg
End Function

Function ReportFolderStatus(fldr)
   Dim msg
   If (objFSO.FolderExists(fldr)) Then
      ReportFolderStatus = true
   Else
      ReportFolderStatus = false
   End If
End Function

Function getAppPath()
	bKey = objShell.RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\pidgin.exe\")
	If Err.Number > 0 Then
		getApps = False
		Err.Clear
		wscript.echo "Pidgin.exe not found. Script stopped!"
		wscript.quit
		'Exit Function
	End If
	getAppPath = bkey
End Function
